;    
;   "" -3.1
;  PIC16F84.
; (c)  , 2006
; http://ksa71.narod.ru
; E-Mail: ksa71@bk.ru

#include p16f84a.inc
 radix dec

 __CONFIG _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC & _PWRTE_OFF

_kbWater	EQU 0
_kbFabric	EQU 1
_kbEMode	EQU 2
_kbProcess	EQU 3
_kbStart	EQU 4
_kbStop		EQU 5
_lvOver		EQU 0
_lvMax		EQU 1
_lvMid		EQU 2
_lvMin		EQU 3
_lvEmpty	EQU 4
_lvPause	EQU 5
_ldWaterMax	EQU 0
_ldWaterMid	EQU 1
_ldWaterMin	EQU 2
_ldFabNorm	EQU 3
_ldFabDense	EQU 4
_ldFabThin	EQU 5
_ldLongWash	EQU 6
_ldShrtWash	EQU 7
_btPump 	EQU 0
_btBackward	EQU 1
_btForward	EQU 2
_ldProcWash	EQU 3
_ldProcRins	EQU 4
_ldProcDry	EQU 5
_ldWater	EQU 6
_ldShortDry	EQU 7
_btSelPort0	EQU 0
_btSelPort1	EQU 1
_btSelKeyb	EQU 2
_btSelLevel	EQU 3
_btSpeaker	EQU 4

;---------------------------------------------------
 CBLOCK 0x0C
_port0
_port1

__BeginInitData:0	;    
_keytmr				;   
_keyold				;   
_Water				;  
_Fabric				;  
_EMode				; . 
_Process			; 
_Mode				;  
_TimerMS
_TimerS
_TimerM

__EndInitData:0   	;    
_SubMode
_InternalMode
_keyb				;  
_level				;   
_CycleTime
_PauseTime
_DirectWash
_WashTimer
_Blink
_BeepFlag
__Save_W
__Save_STATUS
_counter
_kbrddelay
_PauseFlag
_DryTime
 ENDC

;STARTUP   CODE	0x00	; Reset Vector
 org 0
	goto	Init

;intrpt	code	0x04	    ; Interrupt Vector
 org 4
	movwf	__Save_W	    ;  W
	swapf	STATUS,W
	movwf	__Save_STATUS	;  STATUS
	movlw	-71
	movwf	TMR0		    ;   
	bcf		INTCON,T0IF
 ;--- Read Key
	movlw	0xFF
	banksel TRISB
	movwf	TRISB
	banksel PORTA
	bcf 	PORTA,_btSelLevel
	call	ReadPortB
	movwf	_level
	bsf 	PORTA,_btSelLevel
	bcf 	PORTA,_btSelKeyb
	call	ReadPortB
	movwf	_keyb
	bsf 	PORTA,_btSelKeyb

	movf	_keytmr,F
	btfss	STATUS,Z
	decf	_keytmr,F

	btfss	_keyb,_kbStop
	goto	Stop

	movf	_Mode,F         ;  ?
	btfss	STATUS,Z        ;  ,  
	goto 	EndReadKeyb	    ;  

	btfss	_keyb,_kbStart
	goto	Start
	movf	_keytmr,F
	btfss	STATUS,Z
	goto 	EndReadKeyb  	;    
	incfsz	_keyb,W
	goto	KeyPressed
	goto	NoKey
KeyPressed
	btfsc	_keyold,0
	goto 	EndReadKeyb
	bsf 	_keyold,0
	movlw	8
	movwf	_keytmr

	btfss	_keyb,_kbWater
	goto	SetWater
	btfss	_keyb,_kbFabric
	goto	SetFabric
	btfss	_keyb,_kbEMode
	goto	SetEMode
SetProcess
	incf	_Process,F
	movlw	5
	subwf	_Process,W
	btfsc	STATUS,Z
	clrf	_Process
	goto 	EndReadKeyb
SetEMode
	incf	_EMode,F
	movlw	4
	subwf	_EMode,W
	btfsc	STATUS,Z
	clrf	_EMode
	goto 	EndReadKeyb
SetFabric
	incf	_Fabric,F
	movlw	3
	subwf	_Fabric,W
	btfsc	STATUS,Z
	clrf	_Fabric
	goto 	EndReadKeyb
SetWater
	incf	_Water,F
	movlw	3
	subwf	_Water,W
	btfsc	STATUS,Z
	clrf	_Water
	goto 	EndReadKeyb
Start
	bcf 	_PauseFlag,0
	clrf	_SubMode
	incf	_Mode,F
	goto 	EndReadKeyb
Stop
	clrf	_Mode
	goto 	EndReadKeyb
NoKey	           		;   
	bcf 	_keyold,0
EndReadKeyb

;---- Led form
	clrf	PCLATH
	movf	_Fabric,W
	call	GetWF
	movwf	_port0
	swapf	_port0,F
	rrf 	_port0,F
	bsf 	_port0,7
	movf	_Water,W
	call	GetWF
	andwf	_port0,F
	call	GetProcess
	movwf	_port1
	movf	_EMode,W
	addwf	PCL,F
	goto	endLedForm
	goto	GetEMode1
	goto	GetEMode2
	bcf 	_port1,_ldShortDry
endLedForm
	bsf 	_BeepFlag,7		;  
	clrf	_Blink			;  

	incf	_TimerMS,F
	movlw	50
	subwf	_TimerMS,W
	btfss	STATUS,Z
	goto	SwitchMode
	clrf	_TimerMS

	btfss 	_PauseFlag,0
	decf	_DryTime,F

	decf	_TimerS,F
	incfsz	_TimerS,W
	goto	SwitchMode
	movlw	59
	movwf	_TimerS
	decf	_TimerM,F
SwitchMode
	movf	_Mode,W
	addwf	PCL,F
	goto	Exit
	goto	Washing
	goto	Rinsing
	goto	Drying
	movlw	8				;  
	subwf	_TimerS,W
	movlw	7
	btfsc	STATUS,C
	movwf	_TimerS
	movlw	B'00000101'
	andwf	_TimerS,W
	movwf	_BeepFlag
Exit
	movf	_Blink,W
	btfsc	_TimerS,0
	iorwf	_port1,F
	call	OutPorts

WaitTimer
	movlw	-45
	subwf	TMR0,W
	btfss	STATUS,C
	goto	WaitTimer

	swapf	__Save_STATUS,W	;  STATUS
	movwf	STATUS
	swapf	__Save_W,F
	swapf	__Save_W,W		;  W
 	retfie
;---------------------- End Interrupt --------------

GetWF
	addwf	PCL,F
	retlw	B'11111110'
	retlw	B'11111101'
	retlw	B'11111011'

GetProcess
	movf	_Process,W
	addwf	PCL,F
	retlw	B'11000000'
	retlw	B'11110000'
	retlw	B'11100000'
	retlw	B'11001000'
	retlw	B'11011000'

GetEMode1
	bcf 	_port0,_ldLongWash
	goto	endLedForm

GetEMode2
	bcf 	_port0,_ldShrtWash
	goto	endLedForm

Washing
	btfsc	_port1,_ldProcWash
	goto	SkipWash
	bsf 	_Blink,_ldProcWash
	movf	_SubMode,W
	addwf	PCL,F
	goto	InitWash
	goto	Wash
	clrf	_SubMode
SkipWash
	incf	_Mode,F
	goto	Exit

Rinsing
	btfsc	_port1,_ldProcRins
	goto	SkipRins
	bsf 	_Blink,_ldProcRins
	movf	_SubMode,W
	addwf	PCL,F
	goto	InitSliv
	goto	Sliv
	goto	InitWash
	goto	Wash
	goto	ChkShortRins
	goto	Sliv
	goto	InitDrying
	goto	PDrying
	goto	InitWash
	goto	Wash
	goto	InitSliv
	goto	Sliv
	goto	InitDrying
	goto	PDrying
	goto	InitWash
	goto	Wash
	goto	ChkSliv
	goto	Sliv
StopRinsing
	clrf	_SubMode
SkipRins
	incf	_Mode,F
	goto	Exit

Drying
	btfsc	_port1,_ldProcDry
	goto	SkipDry
	bsf 	_Blink,_ldProcDry
	movf	_SubMode,W
	addwf	PCL,F
	goto	InitSliv
	goto	Sliv
	goto	InitDrying
	goto	PDrying
SkipDry
	incf	_Mode,F
	goto	Exit

;--------------------------------------------------

InitWash
	clrf	_TimerMS
	clrf	_TimerS
	clrf	_InternalMode
	incf	_SubMode,F
Wash
	movf	_InternalMode,W
	addwf	PCL,F
	goto	_0_WaitWater
	goto	_1_InitWash
	goto	_2_WashMain
	movf	_TimerS,F
	btfsc	STATUS,Z
	incf	_SubMode,F
	goto	Exit

_0_WaitWater
	movlw	6
	subwf	_TimerS,W
	movlw	5
	btfsc	STATUS,C
	movwf	_TimerS
	bcf 	_port1,_ldWater

	btfss	_level,_lvOver
	goto	OverLevel

	movf	_TimerS,W
	movwf	_BeepFlag
	bsf 	_Blink,_ldWater

	btfss	_port0,_ldWaterMin
	goto	MinLevel
	btfss	_port0,_ldWaterMid
	goto	MidLevel
	btfsc	_level,_lvMax
	goto	Exit
	goto	WaterOK
MidLevel
	btfsc	_level,_lvMid
	goto	Exit
	goto	WaterOK
MinLevel
	btfsc	_level,_lvMin
	goto	Exit
WaterOK
	clrf	_BeepFlag
	bcf 	_Blink,_ldWater
	btfss	_keyb,_kbStart
	incf	_InternalMode,F
	goto	Exit

OverLevel
	bsf 	_port1,_btPump
	clrf	_BeepFlag
	goto	Exit

;----------------------------------------

_1_InitWash
	clrf	_TimerMS
	clrf	_TimerS
	decfsz	_Mode,W			;  ?
	goto	PMode
	call	GetWashTime
	goto	SetM
PMode						; 
	movlw	40
	btfsc	_port0,_ldFabThin
	movwf	_TimerS
	movlw	2
SetM
	movwf	_TimerM
	movlw	50
	btfss	_port0,_ldFabThin
	movlw	90
	movwf	_PauseTime
	movlw	250
	btfss	_port0,_ldFabThin
	movlw	45
	movwf	_CycleTime
	movwf	_WashTimer
	clrf	_DirectWash
	incf	_InternalMode,F

_2_WashMain
	movf	_TimerM,W
	iorwf	_TimerS,W
	btfsc	STATUS,Z
	goto	StopWash
	decfsz	_WashTimer,F
	goto	WashSet
	incf	_DirectWash,F
	movf	_PauseTime,W
	btfss	_DirectWash,0
	movf	_CycleTime,W
	movwf	_WashTimer
WashSet
	btfsc	_DirectWash,0
	goto	Exit
	movlw	1 << _btForward
	btfsc	_DirectWash,1
	movlw	1 << _btBackward
	iorwf	_port1,F
	goto	Exit

StopWash
	clrf	_TimerMS
	movlw	3
	movwf	_TimerS
	incf	_InternalMode,F
	goto	Exit

;------------------------------------------------

ChkSliv
	btfss	_port1,_ldProcDry
	goto	StopRinsing
	goto	InitSliv

ChkShortRins
	btfsc	_port1,_ldProcWash
	goto	StopRinsing
InitSliv
	clrf	_InternalMode
	incf	_SubMode,F
Sliv
	bsf 	_port1,_btPump
	decfsz	_InternalMode,W
	goto	SlivWater
	incfsz	_DryTime,W
	goto	Exit
	incf	_SubMode,F
	goto	Exit
SlivWater
	btfsc	_level,_lvEmpty
	goto	Exit
	movlw	24
	movwf	_DryTime
	clrf	_TimerMS
	incf	_InternalMode,F
	goto	Exit

;---------------------------------------------------

InitDrying
	movlw	24
	movwf	_DryTime
	clrf	_TimerMS
	clrf	_InternalMode
	incf	_SubMode,F

PDrying
	bsf 	_port1,_btPump
	movlw	HIGH __dtbl
	movwf	PCLATH
	movf	_InternalMode,W
__dtbl
	addwf	PCL,F
	goto	i_1
	goto	i_2
	goto	i_3
	goto	i_p
	goto	Dry
	incf	_SubMode,F
	goto	Exit

;-------------------

i_1
	btfsc	_DryTime,1
	goto	i_1s
	btfss	_DryTime,0
	bsf 	_port1,_btForward
i_1s
	incfsz	_DryTime,W
	goto	CheckPause
	movlw	24
	movwf	_DryTime
	incf	_InternalMode,F
i_2
	btfss	_DryTime,0
	bsf 	_port1,_btForward

	incfsz	_DryTime,W
	goto	CheckPause
	movlw	24
	movwf	_DryTime
	incf	_InternalMode,F
i_3
	btfsc	_DryTime,1
	btfss	_DryTime,0
	bsf 	_port1,_btForward

	incfsz	_DryTime,W
	goto	CheckPause
	movlw	30
	movwf	_DryTime
	incf	_InternalMode,F
i_p
	btfss 	_Blink,_ldProcRins
	goto	SetDryTime
	incfsz	_DryTime,W
	goto	Exit
SetDryTime
	incf	_InternalMode,F
	movlw	105
	btfss 	_Blink,_ldProcRins
	call	GetDryTime
	movwf	_DryTime
Dry
	bsf 	_port1,_btForward
	incfsz	_DryTime,W
	goto	CheckPause
	incf	_InternalMode,F
	goto	Exit

CheckPause
	btfsc	_level,_lvPause
	goto	PauseOn
	btfss	_PauseFlag,0
	goto	Exit
	btfsc	_keyb,_kbStart
	goto	Paused
	bcf 	_PauseFlag,0
	goto	Exit

PauseOn
	bsf 	_PauseFlag,0
Paused
	bcf 	_port1,_btForward
	bcf 	_port1,_btPump
	goto	Exit

;------------------------------------------------

GetWashTime
	movlw	HIGH __tb1
	movwf	PCLATH
	movf	_EMode,W
	btfss	_port1,_ldShortDry
	clrw
	addwf	_Fabric,W
	addwf	_Fabric,W
	addwf	_Fabric,W
__tb1
	addwf	PCL,F
	retlw	10
	retlw	15
	retlw	6
	retlw	8
	retlw	10
	retlw	6
	retlw	6
	retlw	9
	retlw	3

;-------------------------------------------------

GetDryTime
	movf	_Fabric,W
	btfss	_port1,_ldShortDry
	addlw	3
	addwf	PCL,F
	retlw	250
	retlw	90
	retlw	60
	retlw	220
	retlw	60
	retlw	60

;-------------------------------------------------

OutPorts
	banksel TRISB
	clrf	TRISB
	banksel PORTB
	movf	_port1,W
	movwf	PORTB
	bsf 	PORTA,1
	bcf 	PORTA,1
	movf	_port0,W
	movwf	PORTB
	bsf 	PORTA,0
	bcf 	PORTA,0
	return

ReadPortB
	movlw	20
	movwf	_kbrddelay
lprb
	decfsz	_kbrddelay,F
	goto	lprb
	movf	PORTB,W
	return

;---------------------- INIT -------------------

Init
	banksel TRISA
	clrf	TRISA
	banksel PORTA
	movlw	B'00001100'
	movwf	PORTA
	movlw	B'11111111'
	movwf	_port0
	movlw	B'11111000'
	movwf	_port1
	call	OutPorts

	movlw	__BeginInitData	;  
	movwf	FSR
	sublw	__EndInitData
	movwf	_counter
Next
	clrf	INDF
	incf	FSR,F
	decfsz	_counter,F
	goto	Next
	bsf 	_BeepFlag,7

	banksel OPTION_REG
	movlw	B'00000100'	; presc=4(1:32), T0CS=0, PSA=0, RBPU=0
	movwf	OPTION_REG
	banksel PORTA
	movlw	B'10100100'
	movwf	INTCON		;    

	movlw	12			;  
Beep
	movf	_BeepFlag,F
	btfss	STATUS,Z
	goto	Beep
	bsf 	PORTA,_btSpeaker
	movwf	_counter
Loop1
	decfsz	_counter,F
	goto	Loop1
	bcf 	PORTA,_btSpeaker
	movwf	_counter
Loop2
	decfsz	_counter,F
	goto	Loop2
	goto	Beep

 END
